//
//  ChatSupport.swift
//  WorkNow
//
//  Created by Javier Arguello on 3/6/17.
//  Copyright © 2017 uoc. All rights reserved.
//

import Foundation
class ChatSupport{

    func correctIdLen(_ id1: String, _ id2: String) -> Bool{
        let lenId1 = id1.characters.count
        let lenId2 = id2.characters.count
        return lenId1 >= 5 && lenId2 >= 5
    }
    func correctNameLen(_ name1: String, _ name2: String) -> Bool{
        let lenName1 = name1.characters.count
        let lenName2 = name2.characters.count
        return lenName1 >= 1 && lenName2 >= 1
    }
    
    func greaterIdentifier(id1: String, id2: String) -> Bool{
        if(id1.compare(id2) == ComparisonResult.orderedDescending){
            return false
        }else{
            return true // CASE EQUALS OR GREATER
        }
    }
    
    func isMyChat(chatId: String, userId: String, name: String, surname: String)-> Bool{
        let chatId2: NSString = chatId as NSString
        
        let substr1 = chatId2.substring(with: NSRange(location: 0, length: 5))
        let substr2 = chatId2.substring(with: NSRange(location: 7, length: 5))
        if userId.range(of: substr1) != nil || userId.range(of: substr2) != nil {
            return true
        }
        return false
    }
    
    func createChatIdentifier(id1: String, id2: String, name1: String, name2: String, surname1: String, surname2: String) -> String {
        var identifier: String = ""
        
        if(correctIdLen(id1,id2) && correctNameLen(name1, name2) && correctNameLen(surname1, surname2)){
            let id1index = id1.index(id1.startIndex, offsetBy: 5)
            let id2index = id2.index(id2.startIndex, offsetBy: 5)
            let n1index = name1.index(name1.startIndex, offsetBy: 1)
            let n2index = name2.index(name2.startIndex, offsetBy: 1)
            let sn1index = surname1.index(surname1.startIndex, offsetBy: 1)
            let sn2index = surname2.index(surname2.startIndex, offsetBy: 1)
            
            identifier = identifier + id1.substring(to: id1index) + name1.substring(to: n1index) + surname1.substring(to: sn1index)
            
            identifier = identifier + id2.substring(to: id2index) + name2.substring(to: n2index) + surname2.substring(to: sn2index)
        }
        return identifier
        
    }

    
    
}
