//
//  DBOperations.swift
//  WorkNow
//
//  Created by Javier Arguello on 11/6/17.
//  Copyright © 2017 uoc. All rights reserved.
//

import Foundation
import Firebase
import FirebaseDatabase
import MapKit


class DBOperations{
    func getUserFromId(userId:String, completion: @escaping (_ user: User) -> ()){
        let dbRef :FIRDatabaseReference = FIRDatabase.database().reference(withPath: "users")
        dbRef.child(userId).observe(.value, with: { snapshot in
            let dictUser = snapshot.value as! NSDictionary
            let userReturned = self.getUser(dictUser: dictUser, userId: userId)
            completion(userReturned)
        }){ (error) in
            print(error.localizedDescription)
            
        }
        
    }
    
    
    
    func getUser(dictUser: NSDictionary, userId: String) -> User{
        let nombre = dictUser["nombre"] as! String
        let email = dictUser["email"] as! String
        let apellidos = dictUser["apellidos"] as! String
        let password = dictUser["password"] as! String
        let latitude = Double(dictUser["latitude"] as! String)
        let longitude = Double(dictUser["longitude"] as! String)
        var user = User(objectId: userId, nombre: nombre, apellidos: apellidos, email: email, password: password)
        user.currentLocation = CLLocationCoordinate2D(latitude: latitude!, longitude: longitude!)
        let oficios = dictUser["oficios"] as! NSArray
        var oficiosList: [Oficio] = []
        for oficio in oficios{
            let profesion = oficio as! NSDictionary
            let pNombre = profesion["nombre"] as! String
            let pSelected = profesion["selected"] as! Bool
            oficiosList += [Oficio(nombre: pNombre,selected: pSelected)]
        }
        user.oficios = oficiosList
        return user
    }
}
