//
//  MisChatsTableViewController.swift
//  WorkNow
//
//  Created by Javier Arguello on 11/6/17.
//  Copyright © 2017 uoc. All rights reserved.
//

import UIKit
import Firebase
import FirebaseDatabase

class MisChatsTableViewController: UITableViewController {

    let ref: FIRDatabaseReference = FIRDatabase.database().reference(withPath: "chats")
    let dbOperations: DBOperations = DBOperations()
    let chatSupport: ChatSupport = ChatSupport()
    var index: Int = 0
    var userChats : [Chat] = []{
        didSet{
            if tableView != nil{
                self.tableView.reloadData()
            }
        }
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        getMyChats()
        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem()
    }
    func getMyChats(){
        userChats = []
        ref.observe(.value, with: { snapshot in
            var chats = snapshot.value as! NSDictionary
        
            for (key, value) in chats {
                let dictChat = value as! NSDictionary
                let chatId = key as! String
                if(self.chatSupport.isMyChat(chatId: chatId, userId: (Global.user?.objectId)!, name: (Global.user?.nombre)!, surname: (Global.user?.apellidos)!)){
                    let usersDict = dictChat["users"] as! NSArray
                    for user in usersDict{
                        let userId = user as! String
                        if(userId != Global.user?.objectId){
                            self.dbOperations.getUserFromId(userId: userId){ user in
                                var chat = Chat(objectId: chatId,user1: Global.user!, user2: user)
                                self.userChats += [chat]
                            }
                        
                        }
                    }
                    
                }
            
            
            }
        }){ (error) in
            print(error.localizedDescription)
        }
    
    }
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int {
        // #warning Incomplete implementation, return the number of sections
        return 1
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // #warning Incomplete implementation, return the number of rows
        return userChats.count
    }

    
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        let cell: UITableViewCell = UITableViewCell(style: UITableViewCellStyle.subtitle, reuseIdentifier: "subtitleCell")
        cell.textLabel?.text = "\(userChats[indexPath.row].user2.nombre) \(userChats[indexPath.row].user2.apellidos)"
        cell.textLabel?.textColor = UIColor.white
        if indexPath.row % 2 == 1{
            cell.backgroundColor = UIColor(red:0.00, green:0.76, blue:0.52, alpha:1.0)
        }else{
            cell.backgroundColor = UIColor(red:0.00, green:0.67, blue:0.45, alpha:1.0)
        }
        return cell
    }
    
    override func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
        index = indexPath.row
        self.performSegue(withIdentifier: "GoToChat", sender: self)
    }
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        if segue.identifier == "GoToChat" {
            let chatViewController = segue.destination as! ChatViewController
            
            chatViewController.user1 = Global.user!
            chatViewController.user2 = userChats[index].user2
            chatViewController.chatId = userChats[index].objectId
        }
    }

    override func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat
    {
        return 100.0;//Choose your custom row height
    }
    
    /*
    // Override to support conditional editing of the table view.
    override func tableView(_ tableView: UITableView, canEditRowAt indexPath: IndexPath) -> Bool {
        // Return false if you do not want the specified item to be editable.
        return true
    }
    */

    /*
    // Override to support editing the table view.
    override func tableView(_ tableView: UITableView, commit editingStyle: UITableViewCellEditingStyle, forRowAt indexPath: IndexPath) {
        if editingStyle == .delete {
            // Delete the row from the data source
            tableView.deleteRows(at: [indexPath], with: .fade)
        } else if editingStyle == .insert {
            // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
        }    
    }
    */

    /*
    // Override to support rearranging the table view.
    override func tableView(_ tableView: UITableView, moveRowAt fromIndexPath: IndexPath, to: IndexPath) {

    }
    */

    /*
    // Override to support conditional rearranging of the table view.
    override func tableView(_ tableView: UITableView, canMoveRowAt indexPath: IndexPath) -> Bool {
        // Return false if you do not want the item to be re-orderable.
        return true
    }
    */

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
