//
//  PerfilViewController.swift
//  WorkNow
//
//  Created by Javier Arguello on 29/4/17.
//  Copyright © 2017 uoc. All rights reserved.
//

import UIKit
import Firebase
import FirebaseAuth

class PerfilViewController: UIViewController, UIPopoverPresentationControllerDelegate, PopOverViewControllerDelegate {
    
    let ref:FIRDatabaseReference = FIRDatabase.database().reference(withPath: "users")

    @IBOutlet weak var nameTextField: UITextField!
    @IBOutlet weak var apTextField: UITextField!
    @IBOutlet weak var emailTextField: UITextField!
    @IBOutlet weak var passTextField: UITextField!
    @IBOutlet weak var pass2TextField: UITextField!
    
    var updatedOficios: [Oficio] = []
    
    override func viewDidLoad() {
        super.viewDidLoad()
        nameTextField.isEnabled=false
        //nameTextField.textColor = UIColor.white
        nameTextField.backgroundColor = UIColor.lightGray

        apTextField.isEnabled=false
       // apTextField.textColor = UIColor.white
        apTextField.backgroundColor = UIColor.lightGray
        emailTextField.isEnabled=false
       // emailTextField.textColor = UIColor.white
        emailTextField.backgroundColor = UIColor.lightGray
        getProfile()
        updatedOficios = Global.user!.oficios
        // Do any additional setup after loading the view.
    }
    
    func dismissKeyboard() {
        //Causes the view (or one of its embedded text fields) to resign the first responder status.
        view.endEditing(true)
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func showAlert(title: String,message: String) {
        let alertController = UIAlertController(title: title, message:
            message, preferredStyle: UIAlertControllerStyle.alert)
        alertController.addAction(UIAlertAction(title: "Aceptar", style: UIAlertActionStyle.default,handler: nil))
        self.present(alertController, animated: true, completion: nil)
    }
    @IBAction func editarClick(_ sender: Any) {
        let pass = passTextField.text!
        let pass2 = pass2TextField.text!
        if(pass.characters.count < 8 ){
            showAlert(title: "Password incorrecto",message: "El password debe tener al menos 8 caracteres")
        }else if(pass != pass2){
            showAlert(title: "Password incorrecto",message: "Los passwords introducidos no coinciden en ambos campos.")
        }else{
            Global.user?.password = pass
            Global.user?.oficios = updatedOficios
            let user = FIRAuth.auth()?.currentUser
            
            self.ref.child(user!.uid).child("password").setValue(pass)
            self.ref.child(user!.uid).child("oficios").setValue(Global.user?.oficiosToAnyObjectList())
            user?.updatePassword(pass) { error in
                if error != nil {
                    // An error happened.
                    self.showAlert(title: "Error actualizando el perfil",message: error!.localizedDescription)
                } else {
                    self.showAlert(title: "Perfil Actualizado",message: "Perfil actualizado correctamente.")
                }
            }
        }
    }
    
    func getProfile()-> Void {
        nameTextField.text = Global.user?.nombre
        apTextField.text = Global.user?.apellidos
        emailTextField.text = Global.user?.email
        passTextField.text = Global.user?.password
        pass2TextField.text = Global.user?.password
    }

    @IBAction func oficiosClick(_ sender: Any) {
    }
    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */
    func updateOficios(oficiosList: [Oficio]) {
        updatedOficios = oficiosList
    }
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        if segue.identifier == "PopOverSegue" {
            let popoverViewController = segue.destination as! PopOverViewController
            popoverViewController.modalPresentationStyle = UIModalPresentationStyle.popover
            popoverViewController.popoverPresentationController!.delegate = self
            popoverViewController.delegate = self
            popoverViewController.oficiosList = (Global.user?.oficios)!
        }
    }
    func adaptivePresentationStyle(for controller: UIPresentationController) -> UIModalPresentationStyle {
        return UIModalPresentationStyle.none
    }
    
    func adaptivePresentationStyle(for controller: UIPresentationController, traitCollection: UITraitCollection) -> UIModalPresentationStyle {
        return UIModalPresentationStyle.none
    }
}
