//
//  PopOverViewController.swift
//  WorkNow
//
//  Created by Javier Arguello on 29/4/17.
//  Copyright © 2017 uoc. All rights reserved.
//

import UIKit
import Firebase
import FirebaseAuth

protocol PopOverViewControllerDelegate: class {
    func updateOficios(oficiosList: [Oficio])
}

class PopOverViewController: UIViewController, UITableViewDelegate, UITableViewDataSource {
    
    
   
    var delegate: PopOverViewControllerDelegate?
    var rowNo : Int = 0;
    var oficiosList: [Oficio] = []{
        didSet{
            if tableView != nil{
                self.tableView.reloadData()
            }
        }
    }
    
    @IBOutlet weak var tableView: UITableView!
    override func viewDidLoad() {
        super.viewDidLoad()
        tableView.delegate = self
        tableView.dataSource = self
        
        // Do any additional setup after loading the view.
    }
    

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func adaptivePresentationStyle(for controller: UIPresentationController) -> UIModalPresentationStyle {
        return UIModalPresentationStyle.none
    }
    


    @IBAction func confirmClick(_ sender: Any) {
        self.delegate?.updateOficios(oficiosList: oficiosList)
        self.dismiss(animated: true, completion: nil);
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if oficiosList.count != 0{
            return oficiosList.count
        }else{
            return 1
        }
    }
    func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {

        if(oficiosList.count != 0){
        let cell = tableView.dequeueReusableCell(
            withIdentifier: "cell",
            for: indexPath) as! SwitchTableViewCell
        cell.configure(with: self.oficiosList[indexPath.row])
        cell.onSwitchValueChanged = { value in
            self.switchChanged(at: indexPath.row, value: value)
            }
            return cell
        }else{
            let cell = tableView.dequeueReusableCell(
                withIdentifier: "SpinCell",
                for: indexPath)
            return cell
        }
        
        
    }
    
    func switchChanged(at row: Int, value: Bool) {
        if oficiosList.count != 0{
            oficiosList[row].selected = value
        }
    }
    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
