//
//  ProfesionalViewController.swift
//  WorkNow
//
//  Created by Javier Arguello on 5/6/17.
//  Copyright © 2017 uoc. All rights reserved.
//

import UIKit
import MapKit
class ProfesionalViewController: UIViewController {

    var profesional : User?
    let chatSupport : ChatSupport = ChatSupport()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        let tap: UITapGestureRecognizer = UITapGestureRecognizer(target: self, action: "dismissKeyboard")
        view.addGestureRecognizer(tap)
        if let prof = profesional{
            nombreTF.text = prof.nombre
            apellidosTF.text = prof.apellidos
            
            let loc1: CLLocation = CLLocation(latitude: prof.currentLocation.latitude, longitude: prof.currentLocation.longitude)
            let loc2: CLLocation = CLLocation(latitude: Global.user!.currentLocation.latitude, longitude: Global.user!.currentLocation.longitude)
            let distance = loc1.distance(from: loc2)
            distanciaField.text = "\((Double(distance).rounded()/1000.0))"
        }
        
        nombreTF.isEnabled = false
        apellidosTF.isEnabled = false
        distanciaField.isEnabled = false
        
        // Do any additional setup after loading the view.
    }
    
    func dismissKeyboard() {
        //Causes the view (or one of its embedded text fields) to resign the first responder status.
        view.endEditing(true)
    }

    @IBOutlet weak var nombreTF: UITextField!
    @IBOutlet weak var apellidosTF: UITextField!
    @IBOutlet weak var distanciaField: UITextField!
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func getChatIdentifier(user1: User, user2: User) -> String{
        var chatId : String = ""
        if(chatSupport.greaterIdentifier(id1: user1.objectId, id2: user2.objectId)){
            chatId = chatSupport.createChatIdentifier(id1: user1.objectId, id2: user2.objectId, name1: user1.nombre, name2: user2.nombre, surname1: user1.apellidos, surname2: user2.apellidos)
        }else{
            chatId = chatSupport.createChatIdentifier(id1: user2.objectId, id2: user1.objectId, name1: user2.nombre, name2: user1.nombre, surname1: user2.apellidos, surname2: user1.apellidos)
            
        }
        return chatId
    }
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        if segue.identifier == "GoToChat" {
            let chatViewController = segue.destination as! ChatViewController
            chatViewController.user1 = Global.user!
            chatViewController.user2 = profesional!
            chatViewController.chatId = getChatIdentifier(user1: Global.user!, user2: profesional!)
        }
    }
    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
