//
//  SwitchTableViewCell.swift
//  WorkNow
//
//  Created by Javier Arguello on 20/5/17.
//  Copyright © 2017 uoc. All rights reserved.
//

import UIKit

class SwitchTableViewCell: UITableViewCell {

    @IBOutlet weak var switchCell: UISwitch! {
        didSet {
            switchCell.addTarget(self, action: #selector(switchValueChanged), for: .valueChanged)
        }
    }
    @IBOutlet weak var oficioLabel: UILabel!
    
    var onSwitchValueChanged: ((Bool) -> Void)?
    
    func configure(with oficio: Oficio) {
        oficioLabel.text = oficio.nombre
        switchCell.isOn = oficio.isSelected
        selectionStyle = .none
    }
    
    @objc func switchValueChanged() {
        onSwitchValueChanged?(switchCell.isOn)
        
    }
}
