//
//  TrabajadorTVController.swift
//  WorkNow
//
//  Created by Javier Arguello on 11/5/17.
//  Copyright © 2017 uoc. All rights reserved.
//

import UIKit
import MapKit
import Firebase
import FirebaseAuth

class TrabajadorTVController: UIViewController, UITableViewDelegate, UITableViewDataSource, CLLocationManagerDelegate {

    var rowNo : Int = 0
    
    let ref:FIRDatabaseReference = FIRDatabase.database().reference(withPath: "users")
    
    let locationManager = CLLocationManager()
    var isUpdatingLocation = false
    var lastLocationError: NSError?
    let authStatus = CLLocationManager.authorizationStatus()
    var location: CLLocation?

    var categoria: String?
    var totalKms : Int = 1
    var usersList: [User] = []{
        didSet{
            if tableView != nil{
                self.tableView.reloadData()
            }
        }
    }
    @IBOutlet weak var stepper: UIStepper!
    @IBOutlet weak var distanciaField: UITextField!
    
    @IBOutlet weak var tableView: UITableView!
    
    func getUser(dictUser: NSDictionary, userId: String) -> User{
        let nombre = dictUser["nombre"] as! String
        let email = dictUser["email"] as! String
        let apellidos = dictUser["apellidos"] as! String
        let password = dictUser["password"] as! String
        let latitude = Double(dictUser["latitude"] as! String)
        let longitude = Double(dictUser["longitude"] as! String)
        var user = User(objectId: userId, nombre: nombre, apellidos: apellidos, email: email, password: password)
        user.currentLocation = CLLocationCoordinate2D(latitude: latitude!, longitude: longitude!)
        return user
    }
    
    func getDistance(to: User) -> Double{
        let loc1: CLLocation = CLLocation(latitude: to.currentLocation.latitude, longitude: to.currentLocation.longitude)
        let loc2: CLLocation = CLLocation(latitude: Global.user!.currentLocation.latitude, longitude: Global.user!.currentLocation.longitude)

        let distance = Double(loc1.distance(from:loc2)).rounded()/1000.0
        print(distance)
        return distance
    }
    
    func withinDistance(prof: User) -> Bool{
        
        let distance = getDistance(to: prof)
        if (Double(totalKms) >= distance){
            return true
        }else{
            return false
        }
    }
    
    @IBAction func buscarClick(_ sender: Any) {
        usersList = []
        let childOficios = ref.observe(.value, with: { snapshot in
            let users = snapshot.value as! NSDictionary
            
            for (key, value) in users {
                let dictUser = value as! NSDictionary
                let userId = key as! String
                var profesional = self.getUser(dictUser: dictUser, userId: key as! String)
                let oficios = dictUser["oficios"] as! NSArray
                var oficiosList: [Oficio] = []
                profesional.oficios = oficiosList
                for oficio in oficios{
                    let profesion = oficio as! NSDictionary
                    let pNombre = profesion["nombre"] as! String
                    let pSelected = profesion["selected"] as! Bool
                    profesional.oficios += [Oficio(nombre: pNombre,selected: pSelected)]
                    if (pNombre == self.categoria! && pSelected == true && userId != Global.user!.objectId && self.withinDistance(prof: profesional)){
                     self.usersList += [profesional]
                     }
                }
                
               // for oficio in
        

            }
        
            if(self.usersList.count == 0){
                self.showAlert(title: "No se encontraron trabajadores", message: "No se encontraron trabajadores de la categoría: "+self.categoria!+". Amplía el rango de búsqueda para encontrar más trabajadores")
            }
/*            if self.tableView != nil{
                self.tableView.reloadData()
                self.tableView.reloadSections(IndexSet(integer: 0), with: .automatic)
            }*/
        }){ (error) in
            print(error.localizedDescription)
        }


    }
    
    
    @IBAction func distChanged(_ sender: Any) {
        distanciaField.text = "\(Int(stepper.value))"
        totalKms = Int(stepper.value)
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        tableView.delegate = self
        tableView.dataSource = self
        distanciaField.text = "\(totalKms)"
        stepper.value = Double(totalKms)
        distanciaField.isEnabled = false
        if let cat = categoria{
            self.navigationItem.title = cat
        }
        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem()
        startLocationManager()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    // MARK: - Table view data source

    func numberOfSections(in tableView: UITableView) -> Int {
        // #warning Incomplete implementation, return the number of sections
        return 1
    }

    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // #warning Incomplete implementation, return the number of rows
        return usersList.count
    }

    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
       // let cell = tableView.dequeueReusableCell(withIdentifier: "Cell", for: indexPath)
        let cell: UITableViewCell = UITableViewCell(style: UITableViewCellStyle.subtitle, reuseIdentifier: "subtitleCell")

        if indexPath.row % 2 == 1{
            cell.backgroundColor = UIColor.gray
            cell.textLabel?.textColor = UIColor.white
            cell.detailTextLabel?.textColor = UIColor.white
        }else{
      //      cell.backgroundColor = UIColor(red:0.00, green:0.67, blue:0.45, alpha:1.0)
        }
        cell.textLabel!.text = usersList[indexPath.row].nombre
        cell.detailTextLabel!.text = "Distancia: \(getDistance(to: usersList[indexPath.row])) kms"
        // Configure the cell...

        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat
    {
        return 70.0//Choose your custom row height
    }

    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
        rowNo = indexPath.row
        self.performSegue(withIdentifier: "GoToPerfil", sender: self)
    }
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        if segue.identifier == "GoToPerfil" {
            let profesionalViewController = segue.destination as! ProfesionalViewController
            profesionalViewController.profesional = usersList[rowNo]
        }
    }
    
    func tableView(tableView: UITableView, viewForHeaderInSection section: Int) -> UIView? {
        
        self.tableView.sectionHeaderHeight = 70
        let view = UIView(frame: CGRect(x: 0, y: 0, width: tableView.frame.size.width, height: 18))
        let label = UILabel(frame: CGRect(x: 20, y: 20, width: 50, height: 50))
        label.text = "Profesionales de: "+categoria!
        label.textColor = UIColor.black
        
        view.addSubview(view)
        
        return view
    }
    
    func tableView(tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        return 70
    }
    
    
    
    func showAlert(title: String,message: String) {
        let alertController = UIAlertController(title: title, message:
            message, preferredStyle: UIAlertControllerStyle.alert)
        alertController.addAction(UIAlertAction(title: "Aceptar", style: UIAlertActionStyle.default,handler: nil))
        self.present(alertController, animated: true, completion: nil)
    }
    
    /*
    // Override to support conditional editing of the table view.
    override func tableView(_ tableView: UITableView, canEditRowAt indexPath: IndexPath) -> Bool {
        // Return false if you do not want the specified item to be editable.
        return true
    }
    */

    /*
    // Override to support editing the table view.
    override func tableView(_ tableView: UITableView, commit editingStyle: UITableViewCellEditingStyle, forRowAt indexPath: IndexPath) {
        if editingStyle == .delete {
            // Delete the row from the data source
            tableView.deleteRows(at: [indexPath], with: .fade)
        } else if editingStyle == .insert {
            // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
        }    
    }
    */

    /*
    // Override to support rearranging the table view.
    override func tableView(_ tableView: UITableView, moveRowAt fromIndexPath: IndexPath, to: IndexPath) {

    }
    */

    /*
    // Override to support conditional rearranging of the table view.
    override func tableView(_ tableView: UITableView, canMoveRowAt indexPath: IndexPath) -> Bool {
        // Return false if you do not want the item to be re-orderable.
        return true
    }
    */

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */
    func startLocationManager() {
        if CLLocationManager.locationServicesEnabled() {
            locationManager.delegate = self
            locationManager.desiredAccuracy = kCLLocationAccuracyNearestTenMeters
            locationManager.startUpdatingLocation()
            isUpdatingLocation = true
        }
    }
    
    func stopLocationManager() {
        if isUpdatingLocation {
            locationManager.stopUpdatingLocation()
            locationManager.delegate = nil
            isUpdatingLocation = false
        }
    }
    
    func locationManager(_ manager: CLLocationManager, didUpdateLocations locations: [CLLocation]){
        let newLocation = locations.last!
        print("didUpdateLocations \(newLocation)")
        if newLocation.timestamp.timeIntervalSinceNow < -5 {
            return
        }
        if newLocation.horizontalAccuracy < 0 {
            return
        }
        if location == nil || location!.horizontalAccuracy > newLocation.horizontalAccuracy {
            lastLocationError = nil
            location = newLocation
        }
        if newLocation.horizontalAccuracy <= locationManager.desiredAccuracy {
            print("Got the desired accuracy")
            stopLocationManager();
        }
    }
    
    
    func locationManager(_ manager: CLLocationManager, didFailWithError error: Error) {
        print("didFailWithError \(error)")
        if error._code == CLError.Code.locationUnknown.rawValue {
            return
        }
        lastLocationError = error as NSError
        stopLocationManager()
    }
}
