//
//  User.swift
//  WorkNow
//
//  Created by Javier Arguello on 20/5/17.
//  Copyright © 2017 uoc. All rights reserved.
//

import Foundation
import MapKit

struct User{
    let objectId : String
    let nombre: String
    let apellidos: String
    let email: String
    var password: String?
    var currentLocation: CLLocationCoordinate2D = CLLocationCoordinate2D(latitude: 0.0, longitude: 0.0)
    var oficios : [Oficio] = []
    var ratings : [Rating] = []
    init(){
        self.objectId = ""
        self.nombre = ""
        self.apellidos = ""
        self.email = ""
        self.password = ""
    }
    init(objectId: String, nombre: String, apellidos: String,
         email: String, password: String) {
        self.objectId = objectId
        self.nombre = nombre
        self.apellidos = apellidos
        self.email = email
        self.password = password
    }
    
    func toAnyObject() -> Any {
        return [
            "nombre": nombre,
            "apellidos": apellidos,
            "email": email,
            "password": password,
            "longitude":"\(currentLocation.longitude)",
            "latitude":"\(currentLocation.latitude)"
        ]
    }
    
    func oficiosToAnyObjectList() -> Any {
        var oficiosList:[Any] = []
        for oficio in oficios{
             oficiosList+=[oficio.toAnyObject()]
        }
        return oficiosList
    }

}
